/*
    ,    , : 
a)     n x m    ; 
b) ,   ; 
c)   ,          ; 
d)        .

*/

// Biblioteki raznyh funkcij
//------------------------------------------------------------------------------

  #include <conio.h> // dlia getch();
  #include <stdio.h> // printf, scanf i drugie
  #include <string.h> // dlia funkcij so strokami( tipa strlen(); )
  #include <stdlib.h> // dlia upravlenija dinami4eskoj pamiatju

// Globalnye peremennye
//------------------------------------------------------------------------------

  // SOzdaem "logi4eskij" tip bool 4toby bylo leg4e
  #define bool int
  #define true 1
  #define false 0

  FILE *input_file; // ukazatel' na fail DANNYH
  FILE *rezultat; // ukazatel' na fail REZULTATOV

  int **matrix = NULL, // dvumernyj massiv: matrica, zdes' hranim s4itannye dannye

             n = 0,// stroki
             m = 0,// stolby

          min1 = 0,// koordinaty pervogo minimuma
          min2 = 0;// vtorogo

// Prototipy funkcij
//------------------------------------------------------------------------------

 // Vydeliaet pamiat' dvumernomu massivu: **matrix, vozvrashiaet, polu4ilos li
 bool CreatMatrix(int n, int m);

 // proveriat, kvadratnaja li matrica
 bool Kvadrat(void);

 // nahodit razmer matricy iz faila dannyh
 bool RaskIsmatavimus(void);

 // stiraet nashu matricu
 void DeleteMatrix(void);

 // s4ityvaet dannye iz faila v matricu
 void ReadData(void); 

 // pokazyvaet matricu na ekrane
 void ShowMatrix(void);

 // sohraniaet matricu v fail
 void ShowMatrixInFile(void);

 // vybiraet dva naimen'shih elementa osnovnyh diagonalej
 void Najdi(void);

 // meniaet mestami vybiraet dva naimen'shih elementa osnovnyh diagonalej 
 void meniaj(void);

//------------------------------------------------------------------------------


// osnovnaja funkcija
//------------------------------------------------------------------------------
int main()
{
 char Dannye[20]; // v etom massive hranim imia dannogo faila
 char Rezultat[20]; // v etom massive hranim imia faila rezultata
           
 // vyvodim zapros
 printf("\n\n Vvedite imia faila s matricoj: ");

 // s4ityvaem imia faila dannyh
 scanf(" %s", &Dannye);

 // vyvodim zapros
 printf("\n\n Vvedite imia faila, v kotorom budet sohranion rezultat: ");

 // s4ityvaem imia faila rezultata
 scanf(" %s", &Rezultat);

 // probuem podgotovit faily k rabote i esli fail nebyl najden...
 if( ( (input_file = fopen(Dannye, "rt")) == NULL )  ||
	 ( (rezultat = fopen(Rezultat, "wt")) == NULL ) )
 { 
   // zakryvaem rabo4ie faily
   if(input_file) fclose(input_file); if(rezultat) fclose(rezultat);

   printf("\n\n Oshibka, faily ne udalos podgotovit k rabote...");
   printf("\n\n\n ZAKON4iT - liubaja klavisha...");

   _getch(); // zaderzhivaem programmu, 4toby smogli posmotret' rezultaty

   return; // vyhodim iz programmy
 }

 // pytaemsia najti razmer matricy
 // jesli nepolu4ilos fiktivno s4itat matricu ili ona 'besporiado4na'..
 if(! RaskIsmatavimus() )
 {
   printf("\n\n Oshibka v faile dannyh... Mozhet byt', poterian kakoj-libo element matricy...");
   if(input_file) fclose(input_file); if(rezultat) fclose(rezultat);
   _getch(); return;
 }

 // probuem vydelit pamiat dlia matricy
 if(! CreatMatrix(n, m) )
 {	                                            // dolzhen byt (n>1) && (m >1)
   printf("\n\n Matrica perepolnena... Ili nepravilnye izmerenija matricy...");
   if(input_file) fclose(input_file); if(rezultat) fclose(rezultat);
   _getch(); return;
 }

 ReadData();

 printf("\n\n s4itannaja matrica( %d x %d ):\n\n", n, m);
 fprintf(rezultat, "\n\n S4itana matrica( %d x %d ):\n\n", n, m);

 // pokazyvaem matricu na ekrane
 ShowMatrix();

 // pe4etaem matricu v fail
 ShowMatrixInFile();

 printf("\n\n Rezultatai:");
 fprintf(rezultat, "\n\n Rezultaty:");


 Najdi(); // nahodim 2 minimumy v diagonaliah

 // esli ustanovili 4to matrica kvadratnaja
 if( Kvadrat() )
 {
  printf("\n\n 1 minimumo kordinaty: (%d; %d), zna4enie = %d.\n\n", min1, min1, matrix[min1][min1]);
  printf(" 2 minimumo kordinaty: (%d; %d), zna4enie = %d.\n\n", min2, min2, matrix[min2][min2]);

  fprintf(rezultat, "\n\n 1 Minimumo koordinaty: (%d; %d), zna4enie = %d.\n\n", min1, min1, matrix[min1][min1]);
  fprintf(rezultat, " 2 minimuma koordinaty: (%d; %d), zna4enie = %d.\n\n", min2, min2, matrix[min2][min2]);
    
  printf(" S4itannaja matrica kvadratnaja.\n\n");
  fprintf(rezultat, " S4itannaja matrica javliaetsia kvadratnoj.\n\n");

  // meniaet nuzhnye elementy
  meniaj();

  printf("\n\n Matrica( %d x %d ) posle zameny:\n\n", n, m);
  fprintf(rezultat, "\n\n Matrica( %d x %d ) posle zameny:\n\n", n, m);

  // pokazyvaem matricu na ekrane
  ShowMatrix();

  // pe4etaem matricu v fail
  ShowMatrixInFile();

  Najdi(); // nahodim 2 minimumy v diagonale

  printf(" 1 minimumo kordinaty: (%d; %d), zna4enie = %d.\n\n", min1, min1, matrix[min1][min1]);
  printf(" 2 minimumo kordinaty: (%d; %d), zna4enie = %d.\n\n", min2, min2, matrix[min2][min2]);

  fprintf(rezultat, "\n\n 1 minimuma kordinaty: (%d; %d), zna4enie = %d.\n\n", min1, min1, matrix[min1][min1]);
  fprintf(rezultat, " 2 minimuma kordinaty: (%d; %d), zna4enie = %d.\n\n", min2, min2, matrix[min2][min2]);
 } else {
         printf("\n\n S4itannaja matrica ne kvadratnaja.");
         fprintf(rezultat, "\n\n S4itannaja matrica ne kvadratnaja.");
        }
  
 // o4ishiaem pamiat
 DeleteMatrix();
   
 // zakryvaem rabo4ie faily
 if(input_file) fclose(input_file); if(rezultat) fclose(rezultat);
 
 printf("\n\n\n ZAKON4IT - liubaja klavisha...");
 
 _getch(); // zaderzhka dlia prosmotra rezultatov
}
//------------------------------------------------------------------------------


// vydeliaem pamiat vumernomu massivu: **matrix, vozvrashiaet, polu4ilos li
//------------------------------------------------------------------------------
bool CreatMatrix(int n, int m)
{
  int i; // ciklu

  if( (n>1) && (m >1) )//esli imeem matricu
  {
    // probuem polu4it pamiat
    if( (matrix = (int **)calloc( n, sizeof(int *) ) ) == NULL ) return false;

    for(i = 0; i < n; i++) matrix[i] = (int *)calloc( m, sizeof(int) );
  }
  else return false;// jesli oshibo4no vvedeny razmery matrecy

  return true;
}
//------------------------------------------------------------------------------

// stiraem matricu
//------------------------------------------------------------------------------
void DeleteMatrix(void)
{
  int i; // ciklu

  for(i = 0; i < n; i++) free( matrix[i] ); // stiraem dannye

  free( matrix ); // stiraem ukazateli
}
//------------------------------------------------------------------------------


// s4ityvaem dannye iz faila
//------------------------------------------------------------------------------
void ReadData(void)
{
  int  i=0, // pozicija v matrice - stroka
       j=0; // pozicija v matrice - stolb

  char eilute[81],
               *p; // ukazatel dlia slova
               
               
  // pozicija v na4alo
  rewind(input_file);    

  // s4ityvaem iz faila po stroke do ee konca
  // p.s s: sizeof(stroka)/sizeof(char) uznaem dlinu massiva stroki

  while( fgets(eilute, sizeof(eilute)/sizeof(char), input_file) != NULL )
  {

   /* naprimer, imeem takuju matricu
           a b c d e f g
           g j u i l o e

           s4ityvanie na4netsia tak: a b c ir t.t
                                 potom: g j u ...

      vobshem s4ityvanie strokami...
   */

   // s4ityvaem 4isla stroki

   //pervyj element
   p = strtok(eilute, " ");
   if(p)
    {
     // konvertiruem s: atoi
     // v INT tip. (const char*) nuzhen dlia perevoda tipov...

     matrix[i][j] = atoi((const char*)p);
     j++; // s4itav odno 4islo perehodim k drugomu..
    }

   // dalnejshie obrashenija s argumentov NULL vozvrashiajut adresa drugih elementov
   while(p)
   { p = strtok(NULL, " ");
     if(p)
     {
      matrix[i][j] = atoi((const char*)p);
      j++; 
     }
   }

    i++; // perehodim na sledujushiuju stroku
    j=0; // perehodim k pervomu stolbcu
  } // end while  
}
//------------------------------------------------------------------------------


// nahodit razmer matricy iz faila dannyh
//------------------------------------------------------------------------------
bool RaskIsmatavimus(void)
{
  int stulpsk=0, // skol'ko nashlo stolbcov
      eilutsk=0, // skol'ko nashlo strok
            l=0; // skol'ko s4italo poslednij raz iz stroki

  char eilute[81],
               *p; // ukazatel dlia poiska slov 
               
  // stavim na na4alnuju poziciju dlia s4ityvanija
  rewind(input_file);
  
  // s4ityvaem iz faila po stroke do ee konca
  // p.s s: sizeof(stroka)/sizeof(char) uznoem dlinu stroki massiva
  
  while( fgets(eilute, sizeof(eilute)/sizeof(char), input_file) != NULL )
  {
   stulpsk = 0; // kazhdoj stroke s4itaem zanogo koli4estvo elementov

   // s4ityvaem iz stroki koli4etsvo elementov i tem samym uznaem
   // skolko stolbcov imeet nasha matrica

   //pervyj element
   p = strtok(eilute, " "); if(p) stulpsk++;

   // Dalnejshie obrashenija s argumentom NULL vozvrashiajut adresa drugih elementov
   while(p) { p = strtok(NULL, " "); if(p) stulpsk++; }

   // esli v strokah raznoe koli4estvo 4isel
   // obryvaem programmu...

   // Tak kak mozhet ne byt' matricy, naprimer:
   /*
     1 2 3 6 5 4
     1 2 3 6 5 8 9 8
     2 5 6
   */

   // esli v odnoj stroke nashli drugoe koli4estvo elementov..
   if( (stulpsk != l) && (stulpsk != EOF) && (eilutsk != 0) ) return false;

   l = stulpsk; // zapominaem poslednee zna4enie

   eilutsk++; // zdes' s4itaem skol'ko strok v matrice
  }

  // perekidyvaem dannye v globalnye peremennye
  n = eilutsk;
  m = stulpsk;

  return true;
}
//------------------------------------------------------------------------------


// rodo matrica ekrane
//------------------------------------------------------------------------------
void ShowMatrix(void)
{
  int i, j, a;

  printf("       ");
  for(a = 0; a < m; a++) printf("%03d  ", a);
  printf("\n");

  printf("     -");
  for(a = 0; a < m; a++) printf("-----");
  printf("-\n");

  for(i = 0; i < n; i++)
  {
   printf(" %03d |", i);

   for(j = 0; j < m; j++) printf(" %3d ", matrix[i][j]);
   printf("|\n");
  }

  printf("     -");
  for(a = 0; a < m; a++) printf("-----");
  printf("-\n\n");  
}
//------------------------------------------------------------------------------


// vyvodit matricu v fail
//------------------------------------------------------------------------------
void ShowMatrixInFile(void)
{
  int i, j, a; // meremennye ciklam...

  //numeracija stolbcov
  fprintf(rezultat, "       ");
  for(a = 0; a < m; a++) fprintf(rezultat, "%03d  ", a);
  fprintf(rezultat, "\n");

  //
  fprintf(rezultat, "     -");
  for(a = 0; a < m; a++) fprintf(rezultat, "-----");
  fprintf(rezultat, "-\n");

  //zapolniaem dannymi
  for(i = 0; i < n; i++)
  {
   fprintf(rezultat, " %03d |", i);//eilutes numeris

   //dannye               // s %03d otpe4ataet naprimer: 005, 006 i t.d.
   for(j = 0; j < m; j++) fprintf(rezultat, " %3d ", matrix[i][j]);
   fprintf(rezultat, "|\n");// na druguju stroku
  }

  // stroka po matrice
  fprintf(rezultat, "     -");
  for(a = 0; a < m; a++) fprintf(rezultat, "-----");
  fprintf(rezultat, "-\n\n"); 
}
//------------------------------------------------------------------------------


// Proveriaet, kvadratnaja li matrica
//------------------------------------------------------------------------------
bool Kvadrat(void)
{
 if( n == m ) return true;

 return false;
}
//------------------------------------------------------------------------------


// ishet dva minimalnyh elementa osnovnyh diagonalej
//------------------------------------------------------------------------------
void Najdi(void)
{
  int i, // ciklui
  last = matrix[0][0]; // poslednij s4itannyj element

  // ishia vsio vremia proveriaem, ne nashli li nuzhnyj element

  // ishem 1 minimum
  for(i = 0; i < n; i++)
  {
   if( matrix[i][i] < last )
   {
    last = matrix[i][i];
    min1 = i;
   }
  }

  last = matrix[0][0];

  // ishem 2 minimum
  for(i = 0; i < n; i++)
  {
   if( (matrix[i][i] < last) && (i != min1) )
   {
    last = matrix[i][i];
    min2 = i;
   }
  }  
}
//------------------------------------------------------------------------------
    

// meniaet dva minimalnyh elementa osnovnyh diagonalej mestami
//------------------------------------------------------------------------------
void meniaj (void)
{
  int temp; // vremennaja peremennaja
                      
  // meniaem elementy
  temp = matrix[min1][min1];
  matrix[min1][min1] = matrix[min2][min2];
  matrix[min2][min2] = temp; 
}
//------------------------------------------------------------------------------
